<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use \Setforms2\Shared\ORM\DateTime;
use \Doctrine\ORM\EntityManager;

class Pla66000ListaPratoSubstituicaoCardapio extends \Teknisa\GER\Controllers\TeknisaCrud {

    private   $entityManager;
    protected $crudService;
    protected $dataSourceManager;
    protected $connection;

    public function __construct($crudService, $parameterBag, Manager $dataSourceManager,$connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->connection = $connection;
	}

    public function saveListaPratoSubstituicao(DTO\Request $request, DTO\Response $response) {
         try {
               $this->connection->beginTransaction();
               $dataSourceNameLista = 'listasubsprato';
               $pratoOrigem = $this->crudService->getRowsToSave($request, $dataSourceNameLista);
               $this->crudService->save($dataSourceNameLista,$pratoOrigem);
               $row = $request->getRow();
               
               if(!empty($row['NMPRATO_DESTINO'])){
                   $row['__new_code_pk'] = 'ITLISTASUBSPRATO';
                   $row['__table_pk'] = 'NRITLISTASUBSPRATO';
                   $newRequest = new DTO\Request\Row($row,"","","");
                   $dataSourceNameItem = 'itlistasubsprato';
                   $pratoDestino = $this->crudService->getRowsToSave($newRequest, $dataSourceNameItem);
                   $pratoDestino[0]['NRLISTASUBSPRATO'] = $pratoOrigem[0]['NRLISTASUBSPRATO'];
                   $this->crudService->save($dataSourceNameItem,$pratoDestino);
               }
               $this->connection->commit();
 	
           } catch (\Exception $e) {
 	           $this->connection->rollback();
               $response->setError(new Error($e->getMessage(), 500));
           }
    }
    
    public function exportarListaAcrescentando(DTO\Request $request, DTO\Response $response) {
         try {
            $this->connection->beginTransaction();
            $rows = $request->getDataSet()->getRows();
            $dataSourceNameLista = 'listasubsprato';
            $dataSourceNameItem = 'itlistasubsprato';
            $pratosNaoExportados = array();
			
            foreach($rows as $key => $row ) {
                $conditions = array(
         		    array(
        			    "columnName" => "CDFILIAL",
        			    "operator" => "=",
        			    "value" => $row['CDFILIAL']
        			    ),
        			array(
        			    "columnName" => "CDSERVFILI",
        			    "operator" => "=",
        			    "value" => $row['CDSERVFILI']
        			    )    
			    );
			    
			    $dataSet = $this->crudService->getFilteredDataSet("listaPratoSub_listaPratoDest", $conditions);
                $dados = $dataSet->getRows();
                $possuiOrigem = false;
                    
               foreach ($dados as $value)
                   if($row['CDPRATOORIG'] == $value['CDPRATOORIG']) $possuiOrigem = true;
                
                if(!$possuiOrigem){
                    $row['__columns_to_return'] = array('NRLISTASUBSPRATO');    
                    $newRequestOrigem = new DTO\Request\Row($row,"","","");
                    $pratoOrigem = $this->crudService->getRowsToSave($newRequestOrigem, $dataSourceNameLista);
                    $this->crudService->save($dataSourceNameLista,$pratoOrigem); 
                    
                 if(!empty($row['NMPRATO_DESTINO'])){     
                    $nrNovo = $this->crudService->getColumnsToReturn();
                    $row['__new_code_pk'] = 'ITLISTASUBSPRATO';
                    $row['__table_pk'] = 'NRITLISTASUBSPRATO';
                    
                    $newRequest = new DTO\Request\Row($row,"","","");
                    $pratoDestino = $this->crudService->getRowsToSave($newRequest, $dataSourceNameItem);
                    $pratoDestino[0]['NRLISTASUBSPRATO'] = $nrNovo[0]['NRLISTASUBSPRATO'];
                    
                    $this->crudService->save($dataSourceNameItem,$pratoDestino); 
                   }
                     
                 }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            $response->setError(new Error($e->getMessage(), 500));
        }
    } 
    
    public function exportarListaSobrepondo(DTO\Request $request, DTO\Response $response) {
         try {
            $this->connection->beginTransaction();
            $rows = $request->getDataSet()->getRows();
            $dataSourceNameLista = 'listasubsprato';
            $dataSourceNameItem = 'itlistasubsprato';
            $pratosNaoExportados = array();
            foreach($rows as $key => $row ) {
                $conditions = array(
             		    array(
            			    "columnName" => "CDFILIAL",
            			    "operator" => "=",
            			    "value" => $row['CDFILIAL']
            			    ),
            			array(
            			    "columnName" => "CDSERVFILI",
            			    "operator" => "=",
            			    "value" => $row['CDSERVFILI']
            			    )    
    			);
    			
    			$dataSet = $this->crudService->getFilteredDataSet("listaPratoSub_listaPratoDest", $conditions);
                $dados = $dataSet->getRows();
                $dataSet->setDataSourceName($dataSourceNameLista);
                $this->dataSourceManager->delete($dataSet);
            }    
            
            foreach($rows as $key => $row ) {
              
                    $row['__columns_to_return'] = array('NRLISTASUBSPRATO');    
                    $newRequestOrigem = new DTO\Request\Row($row,"","","");
                    $pratoOrigem = $this->crudService->getRowsToSave($newRequestOrigem, $dataSourceNameLista);
                    $this->crudService->save($dataSourceNameLista,$pratoOrigem); 
               
                if(!empty($row['NMPRATO_DESTINO'])){  
                    $nrNovo = $this->crudService->getColumnsToReturn();  
                    $row['__new_code_pk'] = 'ITLISTASUBSPRATO';
                    $row['__table_pk'] = 'NRITLISTASUBSPRATO';
                        
                    $newRequest = new DTO\Request\Row($row,"","","");
                    $pratoDestino = $this->crudService->getRowsToSave($newRequest, $dataSourceNameItem);
                    $pratoDestino[0]['NRLISTASUBSPRATO'] = $nrNovo[0]['NRLISTASUBSPRATO'];
                    $this->crudService->save($dataSourceNameItem,$pratoDestino); 
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function importarListaAcrescentando(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        $conditions = array(
 		    array(
			    "columnName" => "CDFILIAL",
			    "operator" => "=",
			    "value" => $row['CDFILIAL']
			    ),
			array(
			    "columnName" => "CDSERVFILI",
			    "operator" => "=",
			    "value" => $row['CDSERVFILI']
			    )    
	    );
	    
	    $conditionsOrigem = array(
 		    array(
			    "columnName" => "CDFILIAL",
			    "operator" => "=",
			    "value" => $row['CDFILIAL_DESTINO']
			    ),
			array(
			    "columnName" => "CDSERVFILI",
			    "operator" => "=",
			    "value" => $row['CDSERVFILI_DESTINO']
			    )    
	    );
	    $dataSet = $this->crudService->getFilteredDataSet("listaPratoSub_listaPratoDest", $conditions);
        $dados = $dataSet->getRows();
        $dataSetOrigem = $this->crudService->getFilteredDataSet("listasubsprato", $conditionsOrigem);
        $listaOrigem = $dataSetOrigem->getRows();
        $dataSourceNameLista = 'listasubsprato';
        $dataSourceNameItem = 'itlistasubsprato';
        $naoImportados = array(); 
        $naoImportadosLocal = array(); 
         
        foreach ($dados as $pratoOrigem) {
            
            if($pratoOrigem['CDFILAUXPRATORIG'] == 'P') {
                // Verifica se o prato ja possui na filial de origem
                $possui = false;
                foreach ($listaOrigem as $prato) {
                    if($pratoOrigem['CDPRATOORIG'] === $prato['CDPRATOORIG'])
                        $possui = true;
                }
                
                if(!$possui) {
                    $nrAntigo = $pratoOrigem['NRLISTASUBSPRATO'];
                    
                    $pratoOrigem['__new_code_pk'] = 'LISTASUBSPRATO';
                    $pratoOrigem['__table_pk'] = 'NRLISTASUBSPRATO';
                    $pratoOrigem['__using_unit'] = $row['__using_unit'];
                    $pratoOrigem['__new_code_length'] = $row['__new_code_length'];
                    $pratoOrigem['__cast_number'] = $row['__cast_number'];
                    $pratoOrigem['CDFILIAL'] = $row['CDFILIAL_DESTINO'];
                    $pratoOrigem['CDSERVFILI'] = $row['CDSERVFILI_DESTINO'];
                    $pratoOrigem['__is_new'] = true;
                    $pratoOrigem['__columns_to_return'] = array('NRLISTASUBSPRATO');
                    
                    $newRequest = new DTO\Request\Row($pratoOrigem,"","","");
                    $pratoOrigem = $this->crudService->getRowsToSave($newRequest, $dataSourceNameLista);
                    $this->crudService->save($dataSourceNameLista,$pratoOrigem);
   
                    if(!($pratoOrigem[0]['CDPRATODEST'] == NULL)) { 
                            $conditions2 = array(
                     		    array(
                    			    "columnName" => "NRLISTASUBSPRATO",
                    			    "operator" => "=",
                    			    "value" =>  $nrAntigo
                    			    )   
                    	    );
                    	    $dadosItemLista = $this->crudService->getFilteredDataSet($dataSourceNameItem, $conditions2);
                            $itemLista = $dadosItemLista->getRows();
                            $nrNovo = $this->crudService->getColumnsToReturn();
                            $itemLista[0]['__new_code_pk'] = 'ITLISTASUBSPRATO';
                            $itemLista[0]['__table_pk'] = 'NRITLISTASUBSPRATO';
                            $itemLista[0]['__using_unit'] = $row['__using_unit'];
                            $itemLista[0]['__new_code_length'] = $row['__new_code_length'];
                            $itemLista[0]['__cast_number'] = $row['__cast_number'];
                            $itemLista[0]['__is_new'] = true;
                            $itemLista[0]['NRLISTASUBSPRATO'] = $nrNovo[0]['NRLISTASUBSPRATO'];
                            $requestItem = new DTO\Request\Row($itemLista[0],"","","");
                            $pratoDestino = $this->crudService->getRowsToSave($requestItem, $dataSourceNameItem);
                            $this->crudService->save($dataSourceNameItem,$pratoDestino);
                     }        
                }else{
                    array_push($naoImportados,$pratoOrigem);
                }
            }else{
                array_push($naoImportadosLocal,$pratoOrigem);
            }
        }
            $response->addDataSet(new DataSet("naoImportados", $naoImportados));
            $response->addDataSet(new DataSet("naoImportadosLocal", $naoImportadosLocal));
    }
    
    public function importarListaSobrepondo(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $conditions = array(
 		    array(
			    "columnName" => "CDFILIAL",
			    "operator" => "=",
			    "value" => $row['CDFILIAL']
			    ),
			array(
			    "columnName" => "CDSERVFILI",
			    "operator" => "=",
			    "value" => $row['CDSERVFILI']
			    )    
        );
	    
	    $conditionsOrigem = array(
            array(
                "columnName" => "CDFILIAL",
			    "operator" => "=",
			    "value" => $row['CDFILIAL_DESTINO']
            ),
			array(
                "columnName" => "CDSERVFILI",
			    "operator" => "=",
			    "value" => $row['CDSERVFILI_DESTINO']
			    )    
            );
            
            
            $dataSet = $this->crudService->getFilteredDataSet("listaPratoSub_listaPratoDest", $conditions);
            $dados = $dataSet->getRows();
            if (empty($dados)) {
                throw new \Exception("listaOrigemVazia");
            }
            $dataSourceNameLista = 'listasubsprato';
            $dataSourceNameItem = 'itlistasubsprato';
            
            $dadosDestino = $this->crudService->getFilteredDataSet("listaPratoSub_listaPratoDest", $conditionsOrigem);
            $dadosDestino->setDataSourceName($dataSourceNameLista);
            $this->dataSourceManager->delete($dadosDestino);
            
            $naoImportadosLocal = array(); 
         
        foreach ($dados as $pratoOrigem) {
            if($pratoOrigem['CDFILAUXPRATORIG'] == 'P') {
                    $nrAntigo = $pratoOrigem['NRLISTASUBSPRATO'];
                    
                    $pratoOrigem['__new_code_pk'] = 'LISTASUBSPRATO';
                    $pratoOrigem['__table_pk'] = 'NRLISTASUBSPRATO';
                    $pratoOrigem['__using_unit'] = $row['__using_unit'];
                    $pratoOrigem['__new_code_length'] = $row['__new_code_length'];
                    $pratoOrigem['__cast_number'] = $row['__cast_number'];
                    $pratoOrigem['CDFILIAL'] = $row['CDFILIAL_DESTINO'];
                    $pratoOrigem['CDSERVFILI'] = $row['CDSERVFILI_DESTINO'];
                    $pratoOrigem['__is_new'] = true;
                    $pratoOrigem['__columns_to_return'] = array('NRLISTASUBSPRATO');
                    
                    $newRequest = new DTO\Request\Row($pratoOrigem,"","","");
                    $pratoOrigem = $this->crudService->getRowsToSave($newRequest, $dataSourceNameLista);
                    $this->crudService->save($dataSourceNameLista,$pratoOrigem);
                    
                    if(!($pratoOrigem[0]['CDPRATODEST'] == NULL)) { 
                        $conditions2 = array(
                 		    array(
                			    "columnName" => "NRLISTASUBSPRATO",
                			    "operator" => "=",
                			    "value" =>  $nrAntigo
                			    )   
                	    );
                	    $dadosItemLista = $this->crudService->getFilteredDataSet($dataSourceNameItem, $conditions2);
                        $itemLista = $dadosItemLista->getRows();
                        $nrNovo = $this->crudService->getColumnsToReturn();
                        $itemLista[0]['__new_code_pk'] = 'ITLISTASUBSPRATO';
                        $itemLista[0]['__table_pk'] = 'NRITLISTASUBSPRATO';
                        $itemLista[0]['__using_unit'] = $row['__using_unit'];
                        $itemLista[0]['__new_code_length'] = $row['__new_code_length'];
                        $itemLista[0]['__cast_number'] = $row['__cast_number'];
                        $itemLista[0]['__is_new'] = true;
                        $itemLista[0]['NRLISTASUBSPRATO'] = $nrNovo[0]['NRLISTASUBSPRATO'];
                        
                        $requestItem = new DTO\Request\Row($itemLista[0],"","","");
                        $pratoDestino = $this->crudService->getRowsToSave($requestItem, $dataSourceNameItem);
                        $this->crudService->save($dataSourceNameItem,$pratoDestino);
                     }
            }else{
                array_push($naoImportadosLocal,$pratoOrigem);
            }
        }
        $response->addDataSet(new DataSet("naoImportadosLocal", $naoImportadosLocal));
    }
}
